hpp-core: hpp::core::PathPlanner Class Reference

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
hpp::core::PathPlanner Class Referenceabstract
Path planning algorithms

`#include <hpp/core/path-planner.hh>`

Inheritance diagram for hpp::core::PathPlanner:
[legend]

## Public Member Functions
virtual | ~PathPlanner ()
virtual const RoadmapPtr_t & | roadmap () const
| Get roadmap.
ProblemConstPtr_t | problem () const
| Get problem.
virtual void | startSolve ()
virtual PathVectorPtr_t | solve ()
virtual void | tryConnectInitAndGoals ()
| Try to connect initial and goal configurations to existing roadmap.
virtual void | oneStep ()=0
| User implementation of one step of resolution.
virtual PathVectorPtr_t | finishSolve (const PathVectorPtr_t &path)
| Post processing of the resulting path.
void | interrupt ()
| Interrupt path planning.
void | maxIterations (const unsigned long int &n)
| Set maximal number of iterations.
unsigned long int | maxIterations () const
| Get maximal number of iterations.
void | timeOut (const double &timeOut)
| set time out (in seconds)
double | timeOut () const
| Get time out.
void | stopWhenProblemIsSolved (bool enable)
PathVectorPtr_t | computePath () const
| Find a path in the roadmap and transform it in trajectory.

## Protected Member Functions
| PathPlanner (const ProblemConstPtr_t &problem)
| PathPlanner (const ProblemConstPtr_t &problem, const RoadmapPtr_t &roadmap)
void | init (const PathPlannerWkPtr_t &weak)
| Store weak pointer to itself.

## Detailed Description

Path planner

Algorithm that computes a path between an initial configuration and a set of goal configurations.

## Constructor & Destructor Documentation

## ◆ ~PathPlanner()

virtual hpp::core::PathPlanner::~PathPlanner | ( |  | ) |
| virtual

## ◆ PathPlanner() [1/2]

hpp::core::PathPlanner::PathPlanner | ( | const ProblemConstPtr_t & | problem | ) |
| protected

Constructor

Create a new roadmap

## ◆ PathPlanner() [2/2]

hpp::core::PathPlanner::PathPlanner | ( | const ProblemConstPtr_t & | problem,
|  | const RoadmapPtr_t & | roadmap
| ) |  |
| protected

Constructor

Store a given roadmap.

## Member Function Documentation

## ◆ computePath()

PathVectorPtr_t hpp::core::PathPlanner::computePath | ( |  | ) | const

Find a path in the roadmap and transform it in trajectory.

## ◆ finishSolve()

virtual PathVectorPtr_t hpp::core::PathPlanner::finishSolve | ( | const PathVectorPtr_t & | path | ) |
| virtual

Post processing of the resulting path.

Reimplemented in hpp::core::PlanAndOptimize.

## ◆ init()

void hpp::core::PathPlanner::init | ( | const PathPlannerWkPtr_t & | weak | ) |
| protected

Store weak pointer to itself.

## ◆ interrupt()

void hpp::core::PathPlanner::interrupt | ( |  | ) |

Interrupt path planning.

## ◆ maxIterations() [1/2]

unsigned long int hpp::core::PathPlanner::maxIterations | ( |  | ) | const
| inline

Get maximal number of iterations.

## ◆ maxIterations() [2/2]

void hpp::core::PathPlanner::maxIterations | ( | const unsigned long int & | n | ) |

Set maximal number of iterations.

## ◆ oneStep()

virtual void hpp::core::PathPlanner::oneStep | ( |  | ) |
| pure virtual

User implementation of one step of resolution.

Implemented in hpp::core::BiRRTPlanner, hpp::core::DiffusingPlanner, hpp::core::pathPlanner::BiRrtStar, hpp::core::pathPlanner::kPrmStar, hpp::core::pathPlanner::SearchInRoadmap, hpp::core::PlanAndOptimize, and hpp::core::VisibilityPrmPlanner.

## ◆ problem()

ProblemConstPtr_t hpp::core::PathPlanner::problem | ( |  | ) | const

Get problem.

## ◆ roadmap()

virtual const RoadmapPtr_t & hpp::core::PathPlanner::roadmap | ( |  | ) | const
| virtual

Get roadmap.

## ◆ solve()

virtual PathVectorPtr_t hpp::core::PathPlanner::solve | ( |  | ) |
| virtual

Solve

Call methods

- startSolve,
- oneStep until a solution is found,
- finishSolve. Users can implement themselves the loop to avoid being trapped in an infinite loop when no solution is found.

## ◆ startSolve()

virtual void hpp::core::PathPlanner::startSolve | ( |  | ) |
| virtual

Initialize the problem resolution

- Set initial and and goal nodes,
- check problem consistency

Reimplemented in hpp::core::BiRRTPlanner, hpp::core::DiffusingPlanner, hpp::core::pathPlanner::BiRrtStar, hpp::core::pathPlanner::kPrmStar, and hpp::core::PlanAndOptimize.

## ◆ stopWhenProblemIsSolved()

void hpp::core::PathPlanner::stopWhenProblemIsSolved | ( | bool | enable | ) |

Make the resolution stop when the problem is solved. If set to `false`, the algorithm stops when maxIterations or timeOut are reached and it is a success if the Problem::target is achieved.

## ◆ timeOut() [1/2]

double hpp::core::PathPlanner::timeOut | ( |  | ) | const
| inline

Get time out.

## ◆ timeOut() [2/2]

void hpp::core::PathPlanner::timeOut | ( | const double & | timeOut | ) |

set time out (in seconds)

## ◆ tryConnectInitAndGoals()

virtual void hpp::core::PathPlanner::tryConnectInitAndGoals | ( |  | ) |
| virtual

Try to connect initial and goal configurations to existing roadmap.

Reimplemented in hpp::core::pathPlanner::kPrmStar, and hpp::core::pathPlanner::SearchInRoadmap.

The documentation for this class was generated from the following file:

- include/hpp/core/path-planner.hh